#ifndef __SERVER_H
#define __SERVER_H

#include <stdio.h>
#include <netinet/in.h>
#include "datatypes.h"

#define DEFAULT_LAUNCHER_VERSION	"14"
#define DEFAULT_GAME_VERSION		"000000000018x"
#define DEFAULT_TICKET			"545sfg4gsxge4tggxxfggsrg4tgxvbbx"

/*
*  signal names
*  strsignal() is not suitable here
*  TODO: get rid of signals which we ain't gonna handle
*/
const char * const signal_names[] = {
/*  0 */ "",
/*  1 */ "SIGHUP",
/*  2 */ "SIGINT",
/*  3 */ "SIGQUIT",
/*  4 */ "SIGILL",
/*  5 */ "SIGTRAP",
/*  6 */ "SIGABRT",
/*  7 */ "SIGBUS",
/*  8 */ "SIGFPE",
/*  9 */ "SIGKILL",
/* 10 */ "SIGUSR1",
/* 11 */ "SIGSEGV",
/* 12 */ "SIGUSR2",
/* 13 */ "SIGPIPE",
/* 14 */ "SIGALRM",
/* 15 */ "SIGTERM",
/* 16 */ "SIGSTKFLT",
/* 17 */ "SIGCHLD",
/* 18 */ "SIGCONT",
/* 19 */ "SIGSTOP",
/* 20 */ "SIGTSTP",
/* 21 */ "SIGTTIN",
/* 22 */ "SIGTTOU",
/* 23 */ "SIGURG",
/* 24 */ "SIGXCPU",
/* 25 */ "SIGXFSZ",
/* 26 */ "SIGVTALRM",
/* 27 */ "SIGPROF",
/* 28 */ "SIGWINCH",
/* 29 */ "SIGIO",
/* 30 */ "SIGPWR",
/* 31 */ "SIGSYS"
};

void MC_Init(int argc, char **argv);
int MC_RunThread(void *(*func)(void*), void *param);
void MC_Cleanup(void);

void MC_InitModules(void);
void MC_LoadModule(char *filename);

void parse_config(char *filename);

void *server_thread(void *param);
void *client_thread(void *sock);

char *strtolower(char *dest, const char *src);

const char *str_signal(int sig);
void signal_handler(int sig);
void init_database_lib(char *lib, int (**init)(void), int (**cleanup)(void), int (**get)(char*, struct usr_t *), int (**put)(char*, struct usr_t *), int (**del)(char*));
#endif /* #ifndef __SERVER_H */