#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include "kv_list.h"
#include "datatypes.h"

extern kv_list *config;
extern kv_list *var_table;

void **list_get_arr(char *key_string)
{
	int i, ret, size = 0;
	char *key = NULL;
	char conf_key[32+1];
	void *ptr = NULL;
	void **array = NULL;

	size_t str_size = strlen(key_string) + 1;
	char *keys = malloc(str_size);
	strcpy(keys, key_string);

	/* Max. number of params is 64. Seems enough. */
	for (i=0; i<64; i++)
	{
		key = strsep(&keys, ",");
		if (key == NULL || strlen(key) < 3)
		{
			continue;
		}

		ret = sscanf(key, "config[%32[^]]", conf_key);
		if (ret == 1)
		{
			ptr = list_get(config, conf_key);
		}
		else
		{
			ptr = list_get(var_table, key);
		}

		size++;
		array = realloc(array, size * sizeof(void *));
		array[size-1] = ptr;
	}

	return array;
}

void *config_get(char *key)
{
	return list_get(config, key);
}