#ifndef _DATATYPES_H
#define _DATATYPES_H

#include <stdint.h>
#include <netinet/in.h>

#define LOGIN_MAX_LEN	20
#define PASS_MAX_LEN	20
#define SESSION_LEN	20

#define CHECK_BIT(var, pos)	((var) & (1 << (pos)))
#define SET_BIT(var, pos)	((var) |= (1 << (pos)))
#define CLEAR_BIT(var, pos)	((var) &= ~(1 << (pos)))

#define USERFLAG_ADMIN	15

struct gpar_t
{
	int socket;
	FILE *log;
	int log_level;

	char *ticket;
	char *game_version;
	char *launcher_version;

	int exit_flag;
};

struct usr_t
{
	char username[LOGIN_MAX_LEN+1];
	char password[PASS_MAX_LEN+1];
	char session[SESSION_LEN+1];
	time_t regtime;
	time_t lastlogin;
	uint16_t flags;
};

struct client_t
{
	int sock;
	struct in_addr addr;
};


void *config_get (char *key);
void **list_get_arr (char *key_list);

#endif /* _DATATYPES_H */